"""
##function: calculating pgc for giving modules.
##input file format:
##1.module: motif1 motif2 motif3 ... motifn (n)
##each line represents a module
##2.lambda:(each line represent a )
## motif1 lambda
## motifk lambda
##...
##to run code: python pgc.py <module_filename><motif_lambda_file_name><input_motif_file><input_seq_file><cutoff>
"""
###################################################
import sys,StatTest,pdb
from StatTest import *
##read in the module
f=open(sys.argv[1],'r')
##read in the lambda
g=open(sys.argv[2],'r')
lg=g.readlines()
g.close()
lg=[item.strip() for item in lg]
lg=[item.split('\t') for item in lg]
lam=lg
##calculating pc
import pc
f3=open(sys.argv[3],'r')
lf3=f3.readlines()
f3.close()

f3.close()
lf3=''.join(lf3)
lf3=lf3.split('>')[1:]
lf3=[item.split('\n')[:-2] for item in lf3]
motifs=[]
for i in lf3:
	t=i[1:]
	t=[item.split(' ') for item in t]
	motifs.append(t)
N=len(motifs)

f4=open(sys.argv[4],'r')
lf4=f4.readlines()
f4.close()
lf4=[item.strip() for item in lf4]
G=len(lf4)
W=[len(item) for item in lf4]
w=float(sum(W))/len(W)

cutoff=float(sys.argv[5])
l=[]
pgc=[]
cut=[]
i_counter=0

fg=open(sys.argv[1]+"_significant",'a')
fh=open(sys.argv[1]+"_corrected_pvalue",'a')
for lf in f:
	lf=lf.strip()
	lf=lf.split(' ')
	if lf[-1][1:-1]!='':
		g=int(lf[-1][1:-1])
		lf=lf[:-1]
		module=[int(item) for item in lf]
		pc_i=pc.pc(module,lam,w)
		try:
			pgc_i=max(1-pbinom(g-1,G,pc_i),0)
			#pdb.set_trace()
			pgc_i=pgc_i*binomial(N,len(module))
			#pdb.set_trace()
			if pgc_i<cutoff:
				module=[str(item) for item in module]
				if len(module)>1:
					module=' '.join(module)
					module=module+' '+'('+str(g)+')'
					fg.write(module+'\n')
					fh.write(str(pgc_i)+'\n')
		except:
			pass
		i_counter+=1
		if i_counter%100==0:
			print(i_counter)

f.close()		
fg.close()
fh.close()


    
        
        
    

