package mpredict;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

public class FimMAX implements IFimProcess{
  private String pathCmd = "";
  private String fileIn = "";
  private String fileOut = "";
  private int support;
  
  
  public FimMAX(String pathToCmd, int support, String fileIn, String fileOut) {
    this.pathCmd = pathToCmd;
    this.support = support;
    this.fileIn = fileIn;
    this.fileOut = fileOut;
  }
  
  
  public Process getProcess() throws IOException{
      final String commandLine = pathCmd+" ";
      final String params = fileIn+" "+support+" /dev/stdout";
      
      System.out.println("FIM execution..."+commandLine+params);
      final Process p = Runtime.getRuntime().exec(commandLine+params);
      return p;
  }
  
  
  public int getSupport(){
    return support;
  }
  
  public String getOutFile(){
    return fileOut;
  }
}
